Index: trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 442)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 443)
@@ -457,4 +457,9 @@
 	void ConstructGeometry(VspBspNode *n, PolygonContainer &cell) const;
 
+	/** Constructs geometry associated with the half space intersections 
+		leading to this node.
+	*/
+	void ConstructGeometry(BspViewCell *vc, PolygonContainer &cell) const;
+
 	/** Construct geometry and stores it in a geometry node container.
 	*/
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 442)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 443)
@@ -495,4 +495,6 @@
 	void ConstructGeometry(BspViewCell *vc, PolygonContainer &cell) const;
 
+	/** Constructs geometry of view cell returning a BSP node geometry type.
+	*/
 	void ConstructGeometry(BspNode *n, BspNodeGeometry &cell) const;
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 442)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 443)
@@ -1688,4 +1688,15 @@
 }
 
+void VspBspTree::ConstructGeometry(BspViewCell *vc, PolygonContainer &cell) const
+{
+	/*
+	TODO
+	vector<VspBspLeaf *> leaves = vc->mBspLeaves;
+
+	vector<VspBspLeaf *>::const_iterator it, it_end = leaves.end();
+
+	for (it = leaves.begin(); it != it_end; ++ it)
+		ConstructGeometry(*it, vcGeom);*/
+}
 
 int VspBspTree::FindNeighbors(VspBspNode *n, vector<VspBspLeaf *> &neighbors, 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 442)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 443)
@@ -1230,4 +1230,5 @@
 										const RayContainer &rays)
 {
+	return 0;// TODO
 	if (!ViewCellsConstructed())
 	{
@@ -1241,6 +1242,6 @@
 	int pvsSize = 0;
 
-	BspViewCellsStatistics vcStats;
-	mVspBspTree->EvaluateViewCellsStats( vcStats);
+	VspBspViewCellsStatistics vcStats;
+	mVspBspTree->EvaluateViewCellsStats(vcStats);
 	Debug << "original view cell partition:\n" << vcStats << endl;
 		
@@ -1294,14 +1295,14 @@
 		iit = ray->bspIntersections.begin();
 
-		BspLeaf *previousLeaf = (*iit).mLeaf;
+		VspBspLeaf *previousLeaf = NULL;//TODO(*iit).mLeaf;
 		++ iit;
 		
 		for (; iit != ray->bspIntersections.end(); ++ iit)
 		{
-			BspLeaf *leaf = (*iit).mLeaf;
+			VspBspLeaf *leaf = NULL;//TODO(*iit).mLeaf;
 
 			if (ShouldMerge(leaf, previousLeaf))
 			{			
-				MergeBspLeafViewCells(leaf, previousLeaf);
+				MergeVspBspLeafViewCells(leaf, previousLeaf);
 
 				++ merged;
@@ -1329,9 +1330,10 @@
 									   const RayContainer &sampleRays)
 {
+	return; // TODO
 	if (!ViewCellsConstructed())
 		return;
 
 	//-- recount pvs
-	BspViewCellsStatistics vcStats;
+	VspBspViewCellsStatistics vcStats;
 	mVspBspTree->EvaluateViewCellsStats(vcStats);
 
@@ -1361,5 +1363,5 @@
 	}
 
-	ExportVspBspPvs(objects, sampleRays);
+//TODO	ExportVspBspPvs(objects, sampleRays);
 }
 
@@ -1474,9 +1476,10 @@
 			else
 			{
-				PolygonContainer cell;
+				PolygonContainer vcGeom;
+
 				// export view cell geometry
-				mVspBspTree->ConstructGeometry(vc, cell);
-				exporter->ExportPolygons(cell);
-				CLEAR_CONTAINER(cell);
+				mVspBspTree->ConstructGeometry(vc, vcGeom);
+				exporter->ExportPolygons(vcGeom);
+				CLEAR_CONTAINER(vcGeom);
 			}
 
@@ -1547,5 +1550,5 @@
 				for	(int j = 0; j < (int)ray->bspIntersections.size(); ++ j)
 				{
-					VspBspLeaf *leaf; // TODO = ray->bspIntersections[j].mLeaf;
+					VspBspLeaf *leaf = NULL; // TODO = ray->bspIntersections[j].mLeaf;
 
 					if (vc == leaf->GetViewCell()) 
@@ -1571,9 +1574,9 @@
 			else
 			{
-				PolygonContainer cell;
+				PolygonContainer vcGeom;
 				// export view cell
-				mVspBspTree->ConstructGeometry(vc, cell);
-				exporter->ExportPolygons(cell);
-				CLEAR_CONTAINER(cell);
+				mVspBspTree->ConstructGeometry(vc, vcGeom);
+				exporter->ExportPolygons(vcGeom);
+				CLEAR_CONTAINER(vcGeom);
 			}
 